<?php

/**
 * Created by PhpStorm.
 * User: crose
 * Date: 12/23/15
 * Time: 7:11 PM
 */


require_once(__DIR__ . '/../../qfq/Constants.php');
require_once(__DIR__ . '/../../qfq/QuickFormQuery.php');
require_once(__DIR__ . '/../../qfq/store/Store.php');
require_once(__DIR__ . '/../../qfq/store/Sip.php');

use PHPUnit\Framework\TestCase;

//class QuickFormQueryTest extends \PHPUnit_Framework_TestCase {

/**
 * Class QuickFormQueryTest
 */
class QuickFormQueryTest extends TestCase {

    private $store;


    public function testProcess() {
        $form = new qfq\QuickFormQuery(['bodytext' => "\n; some comment\n" . TYPO3_FORM . "=testformnameDoNotChange\n"]);
//        $this->assertEquals("", $form->process());
    }
//
//* FORM_LOAD:
//*   Specified in T3 body text with form=<formname>            Returned Store:Typo3
//*   Specified in T3 body text with form={{form}} ':FSRD'      Returned Store:SIP
//*   Specified in T3 body text with form={{form:C:ALNUMX}}     Returned Store:Client
//*   Specified in T3 body text with form={{SELECT registrationFormName FROM Conference WHERE id={{conferenceId:S0}} }}
//     *   Specified in T3 body text with form={{SELECT registrationFormName FROM Conference WHERE id={{conferenceId:C0:DIGIT}} }}
//     *   Specified in SIP
//*
//     * FORM_SAVE:
//     *   Specified in SIP
//*
//     *
//     * @param string $mode FORM_LOAD|FORM_SAVE|FORM_UPDATE
//* @param string $foundInStore
//* @return array|bool|mixed|null|string  Formname (Form.name) or FALSE, if no formname found.
//     * @throws CodeException
//* @throws UserFormException
//*/

    public function testGetFormName() {

        // <empty> bodytext
        $t3data[T3DATA_BODYTEXT] = "\n   \n \n";
        $t3data[T3DATA_UID] = "123";
        $qfq = new qfq\QuickFormQuery($t3data, true);
        $result = $qfq->getFormName(FORM_LOAD, $foundInStore);
        $this->assertEquals('', $result);

        // form=
        $t3data[T3DATA_BODYTEXT] = "\n   \n" . TYPO3_FORM . "=\n";
        $t3data[T3DATA_UID] = "123";
        $qfq = new qfq\QuickFormQuery($t3data, true);
        $result = $qfq->getFormName(FORM_LOAD, $foundInStore);
        $this->assertEquals('', $result);

        // form=<formname>
        $t3data[T3DATA_BODYTEXT] = "\n   \n" . TYPO3_FORM . "=myForm\n";
        $t3data[T3DATA_UID] = "123";
        $qfq = new qfq\QuickFormQuery($t3data, true);
        $result = $qfq->getFormName(FORM_LOAD, $foundInStore);
        $this->assertEquals('myForm', $result);

        // form={{SELECT 'nextForm'}}
        $t3data[T3DATA_BODYTEXT] = "\n   \n" . TYPO3_FORM . "={{SELECT 'nextForm'}}\n";
        $t3data[T3DATA_UID] = "123";
        $qfq = new qfq\QuickFormQuery($t3data, true);
        $result = $qfq->getFormName(FORM_LOAD, $foundInStore);
        $this->assertEquals('nextForm', $result);

        // form={{form:C:alnumx}}
        $t3data[T3DATA_BODYTEXT] = "\n   \n" . TYPO3_FORM . "={{form:C:alnumx}}\n";
        $t3data[T3DATA_UID] = "123";
        $_SERVER['form'] = 'formNameViaGet';
        $qfq = new qfq\QuickFormQuery($t3data, true);
        $result = $qfq->getFormName(FORM_LOAD, $foundInStore);
        $this->assertEquals('formNameViaGet', $result);

        // form={{form}}
//        $sip = new qfq\Sip('fakesessionname', true);
//        $sip->sipUniqId('badcaffee1234');
//        $t3data[T3DATA_BODYTEXT] = "\n   \n" . TYPO3_FORM . "={{form}}\n";
//        $t3data[T3DATA_UID] = "123";
//        $_SERVER[CLIENT_SIP]='badcaffee1234';
//        $dummy = $sip->queryStringToSip("http://example.com/index.php?id=input&r=1&form=person", RETURN_URL);
//        $qfq = new qfq\QuickFormQuery($t3data, true);
//        $result = $qfq->getFormName(FORM_LOAD, $foundInStore);
//        $this->assertEquals('person', $result);


    }

}
